%global debug_package %{nil}
# since we have only a static library

Summary:       ANother Tool for Language Recognition
Name:          antlr
Version:       2.7.7
Release:       %mkrel 72
Group:         Development/Java
License:       ANTLR-PD
URL:           https://www.antlr2.org/

# ./generate-tarball.sh
Source0:       antlr-%{version}.tar.gz
Source1:       %{name}-build.xml
Source2:       %{name}-script
Source3:       http://repo2.maven.org/maven2/antlr/antlr/%{version}/%{name}-%{version}.pom
# Repack the tarball without prebuilt binaries of unknown origin
Source4:       generate-tarball.sh
Patch1:        %{name}-%{version}-newgcc.patch

BuildRequires: gcc-c++
BuildRequires: make
BuildRequires: ant
BuildRequires: java-devel
BuildRequires: javapackages-local

%description
ANTLR, ANother Tool for Language Recognition, (formerly PCCTS) is a
language tool that provides a framework for constructing recognizers,
compilers, and translators from grammatical descriptions containing
C++ or Java actions [You can use PCCTS 1.xx to generate C-based
parsers].

%package     tool
Summary:       ANother Tool for Language Recognition
Provides:      %{name} = %{version}-%{release}
# Explicit requires for javapackages-tools since antlr-script
# uses /usr/share/java-utils/java-functions
Requires:      javapackages-tools
BuildArch:     noarch

%description tool
ANTLR, ANother Tool for Language Recognition, (formerly PCCTS) is a
language tool that provides a framework for constructing recognizers,
compilers, and translators from grammatical descriptions containing
C++ or Java actions [You can use PCCTS 1.xx to generate C-based
parsers].

%package     manual
Summary:       Manual for %{name}
BuildArch:     noarch

%description manual
Documentation for %{name}.

%package     javadoc
Summary:       Javadoc for %{name}
BuildArch:     noarch

%description javadoc
Javadoc for %{name}.

%package     C++
Summary:       C++ bindings for antlr2 generated parsers
Provides:      antlr-static = %{version}-%{release}

%description C++
This package provides a static C++ library for parsers generated by ANTLR2.

%prep
%setup -q
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
cp -p %{SOURCE1} build.xml
%patch -P 1
# CRLF->LF
sed -i 's/\r//' LICENSE.txt

# set jar location
%mvn_file %{name}:%{name} %{name}

%build
ant -Dj2se.apidoc=%{_javadocdir}/java
# make expects to find it here
cp work/lib/antlr.jar .
export CLASSPATH=.
%configure --without-examples
make CXXFLAGS="${CXXFLAGS} -fPIC" DEBUG=1 verbose=1
# no longer needed
rm antlr.jar

# fix doc permissions and remove Makefiles
rm doc/{Makefile,Makefile.in}
chmod 0644 doc/*

%install
# jars, POM and depmap
%mvn_artifact %{SOURCE3} work/lib/%{name}.jar
%mvn_alias %{name}:%{name} %{name}:%{name}all
%mvn_install -J work/api

mkdir -p $RPM_BUILD_ROOT{%{_includedir}/%{name},%{_libdir},%{_bindir}}
# script
install -p -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/antlr

# C++ lib and headers, antlr-config
install -p -m 644 lib/cpp/antlr/*.hpp $RPM_BUILD_ROOT%{_includedir}/%{name}
install -p -m 644 lib/cpp/src/libantlr.a $RPM_BUILD_ROOT%{_libdir}
install -p -m 755 scripts/antlr-config $RPM_BUILD_ROOT%{_bindir}

%files tool -f .mfiles
%license LICENSE.txt
%{_bindir}/antlr

# this is actually a development package for the C++ target
# as we ship only a static library, it doesn't make sense
# to have a separate -devel package for the headers
%files C++
%license LICENSE.txt
%{_includedir}/%{name}
%{_libdir}/libantlr.a
%{_bindir}/antlr-config

%files manual
%license LICENSE.txt
%doc doc/*

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt


%changelog
* Sat Dec 21 2024 pterjan <pterjan> 2.7.7-72.mga10
+ Revision: 2127115
- Rebuild for patchN deprecation

* Tue May 21 2024 ns80 <ns80> 2.7.7-71.mga10
+ Revision: 2065516
- rebuild for java 21

* Mon Jul 25 2022 neoclust <neoclust> 2.7.7-70.mga9
+ Revision: 1871488
- Rebuild with java17
+ umeabot <umeabot>
- Mageia 9 Mass Rebuild

* Fri Sep 11 2020 daviddavid <daviddavid> 0:2.7.7-45.mga8
+ Revision: 1624519
- Set javac source / target version to 1.8 to fix issues with Java 11
- Rebuilt for JDK-11

* Thu Mar 05 2020 daviddavid <daviddavid> 0:2.7.7-44.mga8
+ Revision: 1554088
- drop python2 support
- Repack the tarball without binaries
- Switch to new license tag: ANTLR-PD
- Conditionally allow building without C++ docs
- Add conditional for python
- Proper python2 subpackage name
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild

* Fri Sep 21 2018 umeabot <umeabot> 0:2.7.7-43.mga7
+ Revision: 1294342
- Mageia 7 Mass Rebuild

* Fri Jun 29 2018 pterjan <pterjan> 0:2.7.7-42.mga7
+ Revision: 1240801
- Update scripts to know about aarch64

* Wed Mar 02 2016 neoclust <neoclust> 0:2.7.7-41.mga6
+ Revision: 981796
- Second rebuild of the java stack

* Sun Feb 21 2016 neoclust <neoclust> 0:2.7.7-40.mga6
+ Revision: 975458
- First rebuild of the java stack
- sync package antlr with fedora

* Tue Feb 09 2016 umeabot <umeabot> 0:2.7.7-31.mga6
+ Revision: 951866
- Mageia 6 Mass Rebuild

* Thu Jan 08 2015 pterjan <pterjan> 0:2.7.7-30.mga5
+ Revision: 809288
- Sync with Fedora 21

* Wed Oct 15 2014 umeabot <umeabot> 0:2.7.7-29.mga5
+ Revision: 741299
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 0:2.7.7-28.mga5
+ Revision: 725941
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 0:2.7.7-27.mga5
+ Revision: 677779
- Mageia 5 Mass Rebuild

* Sat May 31 2014 pterjan <pterjan> 0:2.7.7-26.mga5
+ Revision: 628101
- Rebuild for new Python

* Tue Oct 22 2013 dmorgan <dmorgan> 0:2.7.7-25.mga4
+ Revision: 546140
- Temporarly add a mvn() provide

* Tue Oct 22 2013 umeabot <umeabot> 0:2.7.7-24.mga4
+ Revision: 545793
- Mageia 4 Mass Rebuild

* Thu Oct 17 2013 dmorgan <dmorgan> 0:2.7.7-23.mga4
+ Revision: 501809
- Rebuild with new javapackages-tools

* Mon Oct 14 2013 pterjan <pterjan> 0:2.7.7-22.mga4
+ Revision: 497633
- Rebuild to add different pythonegg provides for python 2 and 3

* Fri Jan 11 2013 umeabot <umeabot> 0:2.7.7-21.mga3
+ Revision: 345601
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Dec 03 2012 dmorgan <dmorgan> 0:2.7.7-20.mga3
+ Revision: 325716
- Add Maven Pom

* Fri Nov 16 2012 fwang <fwang> 0:2.7.7-19.mga3
+ Revision: 318881
- cleanup spec

* Wed Apr 27 2011 dmorgan <dmorgan> 0:2.7.7-18.mga3
+ Revision: 92122
- Fix obsoletes

* Wed Apr 27 2011 dmorgan <dmorgan> 0:2.7.7-17.mga1
+ Revision: 92118
- Fix buildrequires
- Fix buildrequires
- Sync with fedora package

* Tue Jan 11 2011 dmorgan <dmorgan> 0:2.7.7-11.mga1
+ Revision: 6080
- imported package antlr

